#  Copyright notice
#   --------------------------------------------------------------------
#   Copyright (C) 2014 Deltares for FAST project
#       Giorgio Santinelli
#
#       giorgio.santinelli@deltares.nl
#
#   This library is free software: you can redistribute it and/or modify
#   it under the terms of the GNU General Public License as published by
#   the Free Software Foundation, either version 3 of the License, or
#   (at your option) any later version.
#
#   This library is distributed in the hope that it will be useful,
#   but WITHOUT ANY WARRANTY; without even the implied warranty of
#   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#   GNU General Public License for more details.
#
#   You should have received a copy of the GNU General Public License
#   along with this library.  If not, see <http://www.gnu.org/licenses/>.
#   --------------------------------------------------------------------
#
# This tool is part of <a href="http://www.OpenEarth.eu">OpenEarthTools</a>.
# OpenEarthTools is an online collaboration to share and manage data and
# programming tools in an open source, version controlled environment.
# Sign up to recieve regular updates of this function, and to contribute
# your own tools.

# $Id$
# $Date$
# $Author$
# $Revision$
# $HeadURL$
# $Keywords$

## make PNG plan view

# for WPS: see http://matplotlib.org/faq/environment_variables_faq.html#envvar-MPLCONFIGDIR
# add to ..\apache\...\pywps.cgi: os.environ['MPLCONFIGDIR']='C:/Python27/Lib/site-packages/matplotlib/mpl-data' 
import os, netCDF4
import numpy as np
# http://matplotlib.org/faq/howto_faq.html#howto-webapp
# import matplotlib
# matplotlib.use('Agg') # use non-interactive plot window on server
# import matplotlib.pyplot as plt

## local settings
# demfile = r'n:\Projects\1207000\1207298\B. Measurements and calculations\WP5\data\data\giorgio_calculations\DEM2netcdf\dem_clip_wgs84.nc'
# demfile = r'http://198.51.100.4:8080/thredds/dodsC/opendap/dem_clip_wgs84.nc'

def profile2json(jsonFile,lon,lat,z):
    "returns a profile from start and end of it"
    
    # # transform to json
    ttt = np.vstack((lon,lat,z))
    fftext = "["
    for ii in np.arange(len(lon)):
        if ii != len(lon)-1:
            fftext += '[%3.5f,%2.5f,%2.3f]'  % (ttt[0,ii],ttt[1,ii],ttt[2,ii]) + ","
        else:
            fftext += '[%3.5f,%2.5f,%2.3f]'  % (ttt[0,ii],ttt[1,ii],ttt[2,ii])
    fftext += "]"

    return fftext

