#  Copyright notice
#   --------------------------------------------------------------------
#   Copyright (C) 2014 Deltares for FAST project
#       Giorgio Santinelli
#
#       giorgio.santinelli@deltares.nl
#
#   This library is free software: you can redistribute it and/or modify
#   it under the terms of the GNU General Public License as published by
#   the Free Software Foundation, either version 3 of the License, or
#   (at your option) any later version.
#
#   This library is distributed in the hope that it will be useful,
#   but WITHOUT ANY WARRANTY; without even the implied warranty of
#   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#   GNU General Public License for more details.
#
#   You should have received a copy of the GNU General Public License
#   along with this library.  If not, see <http://www.gnu.org/licenses/>.
#   --------------------------------------------------------------------
#
# This tool is part of <a href="http://www.OpenEarth.eu">OpenEarthTools</a>.
# OpenEarthTools is an online collaboration to share and manage data and
# programming tools in an open source, version controlled environment.
# Sign up to recieve regular updates of this function, and to contribute
# your own tools.

# $Id$
# $Date$
# $Author$
# $Revision$
# $HeadURL$
# $Keywords$

## make PNG plan view

# for WPS: see http://matplotlib.org/faq/environment_variables_faq.html#envvar-MPLCONFIGDIR
# add to ..\apache\...\pywps.cgi: os.environ['MPLCONFIGDIR']='C:/Python27/Lib/site-packages/matplotlib/mpl-data' 
import os, netCDF4
import numpy as np
# http://matplotlib.org/faq/howto_faq.html#howto-webapp
import matplotlib
matplotlib.use('Agg') # use non-interactive plot window on server
import matplotlib.pyplot as plt

import logging

## local settings
demfile = r'n:\Projects\1207000\1207298\B. Measurements and calculations\WP5\data\data\giorgio_calculations\DEM2netcdf\dem_clip_wgs84.nc'
demfile = r'http://198.51.100.4:8080/thredds/dodsC/opendap/dem_clip_wgs84.nc'
#demfile = r'dem_clip_wgs84.nc'

def transect2profile(Filepath,lat0,lon0,lat1,lon1):
    "returns a profile from start and end of it"
    
    # Filepath = 'http://198.51.100.4:8080/thredds/dodsC/opendap/dem_clip_wgs84.nc'
    # lat0 = 36.399
    # lon0 = -6.2
    # lat1 = 36.4
    # lon1 = -6.0
    logging.info(Filepath)
    lat = netCDF4.Dataset(Filepath).variables['lat'][:]
    lon = netCDF4.Dataset(Filepath).variables['lon'][:]
    # TAKE only a SUBSET
    id_lat = np.arange(np.abs(lat-lat0).argmin(),np.abs(lat-lat1).argmin()+1)
    id_lon = np.arange(np.abs(lon-lon0).argmin(),np.abs(lon-lon1).argmin()+1)
    
    Zsub = netCDF4.Dataset(Filepath).variables['Band1'][id_lat,id_lon]
    
    ## use arange for a subset ?
    latsub = lat[id_lat]
    lonsub = lon[id_lon]
    
    # xii = lonsub[::10]
    # yii = latsub[::10]
    xii = lonsub
    yii = latsub
    
    
    if '_fillvalue' in Zsub:
        Zsub.data[Zsub.data==Zsub._fillvalue]=0
        # Zii = Zsub.data[::10,::10]
        Zii = Zsub.data
    else:
        # Zii = Zsub[::10,::10]
        Zii = Zsub
    
    # Z.fill_value = np.nan
    # Z.data[Z.data==np.min(Z.data)]=0
    
    ## DO THE INTERPOLATION
    from scipy import interpolate
    # f = interpolate.interp2d(X, Y, Zii, kind='linear')
    f = interpolate.RectBivariateSpline(yii, xii, Zii, kx=1, ky=1, s=0)
    
    # TR_lon = np.linspace(-6.2, -6.0, num=1e2)
    # TR_lat = np.linspace(36.4, 36.4, num=1e2)
    TR_lon = np.linspace(lon0, lon1, num=1e3)
    TR_lat = np.linspace(lat0, lat1, num=1e3)
    znew = f(TR_lat, TR_lon)
    plt.plot(TR_lon, znew[0], 'ro-')
    
    return TR_lon, TR_lat, znew[0]
    

